
# declarations of the picture object type ...
DeclareCategory("IsPictureObject", IsObject);
BindGlobal("PictureObjectFamily",
	   NewFamily("PictureObjectFamily", IsPictureObject));

# PictureObject operations
DeclareOperation("SquareDistance", [ IsPictureObject, IsPictureObject ]);
# Draw object should return the object that was placed on the graphic sheet
DeclareOperation("DrawObject", [ IsPictureObject, IsGraphicSheet ]);

# the default implementations of these two assume that the picture object
# is a objectified record and has an attribute marks.  If it is not, you
# will have to provide appropriate methods.
DeclareOperation("AddMark", [ IsPictureObject, IsString ]);
DeclareOperation("DelMark", [ IsPictureObject, IsString ]);
DeclareOperation("HasMark", [ IsPictureObject, IsString ]);

DeclareGlobalFunction("ColourObject");


# the picture object configuration ...
DeclareCategory("IsConfiguration", IsObject);
BindGlobal("ConfigurationFamily",
	   NewFamily("ConfigurationFamily", IsConfiguration));

# Configuration operations ...
DeclareOperation("ConfigWindowArea", [ IsConfiguration ]);
DeclareOperation("RandomNewObject", [ IsConfiguration, IsFunction ]);
DeclareOperation("ChooseRandomObject", [ IsConfiguration ]);
DeclareOperation("AddObject", [ IsConfiguration, IsPictureObject ]);
DeclareOperation("DelObject", [ IsConfiguration, IsPictureObject ]);
DeclareOperation("CountObjects", [ IsConfiguration ]);
DeclareOperation("CountObjectsWithMark", [ IsConfiguration, IsString ]);
DeclareOperation("GetObjectsWithMark", [ IsConfiguration, IsString ]);
DeclareOperation("CloseObjects", [ IsConfiguration, IsPictureObject, IsScalar ]);
DeclareOperation("CloseObjectsWithMark", [ IsConfiguration, IsPictureObject, IsScalar, IsString ]);
DeclareOperation("DrawConfiguration", [ IsConfiguration, IsGraphicSheet ]);


# change objects ...
DeclareCategory("IsChange", IsObject);
BindGlobal("ChangeFamily",
	   NewFamily("ChangeFamily", IsChange));

DeclareOperation("ApplyChange", [ IsChange, IsConfiguration ]);
DeclareOperation("RevertChange", [ IsChange, IsConfiguration ]);
