# default implementations of the mark APIs

InstallMethod(AddMark, "default AddMark method for PictureObjects",
    true, [ IsPictureObject, IsString ],
    function (pobj, mark)
	AddSet(pobj!.marks, mark);
    end);
InstallMethod(DelMark, "default DelMark method for PictureObjects",
    true, [ IsPictureObject, IsString ],
    function (pobj, mark)
	RemoveSet(pobj!.marks, mark);
    end);
InstallMethod(HasMark, "default HasMark method for PictureObjects",
    true, [ IsPictureObject, IsString ],
    function (pobj, mark)
	return mark in pobj!.marks;
    end);

InstallGlobalFunction(ColourObject,
    function(obj, gobj)
        if HasMark(obj, "black") then
            Recolour(gobj, COLOURS.black);
        elif HasMark(obj, "red") then
            Recolour(gobj, COLOURS.red);
        fi;
    end);