InstallGlobalFunction(CreateIterContinueCheck,
    function (niter)
        local iterdone;

        iterdone := 0;
        return function(cnf, change, prob, accepted)
            iterdone := iterdone + 1;
            return iterdone < niter;
        end;
    end);

InstallGlobalFunction(CreateAcceptFlagContinueCheck,
    function (accept)
        return function(cnf, change, prob, accepted)
            return accept <> accepted;
        end;
    end);

InstallGlobalFunction(CreateAcceptFlagLimitContinueCheck,
    function (accept, max_iter)
        local iterdone;

        iterdone := 0;
        return function(cnf, change, prob, accepted)
            iterdone := iterdone + 1;
            return accept <> accepted and iterdone < max_iter;
        end;
    end);

InstallGlobalFunction(CreateChangeTypeContinueCheck,
    function (category_check)
        return function(cnf, change, prob, accepted)
            return not category_check(change);
        end;
    end);

InstallGlobalFunction(CreateChangeTypeLimitContinueCheck,
    function (category_check, max_iter)
        local iterdone;

        iterdone := 0;
        return function(cnf, change, prob, accepted)
            iterdone := iterdone + 1;
            return not category_check(change) and iterdone < max_iter;
        end;
    end);

