InstallGlobalFunction(GUISimulate,
    function(arg)
        local cnf, title, width, height, propose, check, fd, len, gs;

	len := Length(arg);
	if len <> 6 and len <> 7 then
          Error("must pass 6 or 7 arguments");
        fi;
        cnf := arg[1];
        title := arg[2];
        width := arg[3];
        height := arg[4];
        propose := arg[5];
        check := arg[6];
        if len = 7 then
          fd := arg[7];
        else
          fd := OutputTextNone();
        fi;

        gs := GraphicSheet(title, width, height);
        Menu(gs, "Iterate", [
            "1 iter", function(gs, menu, name)
                SimulateGS(cnf, CreateIterContinueCheck(1),
                           propose, check, fd, 1, gs);
            end,
            "10 iter", function(gs, menu, name)
                SimulateGS(cnf, CreateIterContinueCheck(10),
                           propose, check, fd, 10, gs);
            end,
            "100 iter", function(gs, menu, name)
                SimulateGS(cnf, CreateIterContinueCheck(100),
                           propose, check, fd, 100, gs);
            end,
            "1000 iter", function(gs, menu, name)
                SimulateGS(cnf, CreateIterContinueCheck(1000),
                           propose, check, fd, 1000, gs);
            end ]);
        Menu(gs, "Condition", [
            "Until first acceptance", function(gs, menu, name)
                SimulateGS(cnf, CreateAcceptFlagContinueCheck(true),
                           propose, check, fd, 5, gs);
            end,
            "Until first acceptance (max 100 iter)", function(gs, menu, name)
                SimulateGS(cnf, CreateAcceptFlagLimitContinueCheck(true, 100),
                           propose, check, fd, 5, gs);
            end,
            "Until first rejection", function(gs, menu, name)
                SimulateGS(cnf, CreateAcceptFlagContinueCheck(false),
                           propose, check, fd, 5, gs);
            end,
            "Until first rejection (max 100 iter)", function(gs, menu, name)
                SimulateGS(cnf, CreateAcceptFlagLimitContinueCheck(false, 100),
                           propose, check, fd, 5, gs);
            end,
            "Until propose add object (max 100 iter)", function(gs, menu, name)
                SimulateGS(cnf, CreateChangeTypeLimitContinueCheck(IsAddObjectChange, 100),
                           propose, check, fd, 5, gs);
            end,
            "Until propose delete object (max 100 iter)", function(gs, menu, name)
                SimulateGS(cnf, CreateChangeTypeLimitContinueCheck(IsDelObjectChange, 100),
                           propose, check, fd, 5, gs);
            end ]);
        return gs;
    end);
