InstallGlobalFunction(Simulate,
    function(cnf, continue_check, propose, check, fd)
        local i, change, prob, flip, accepted;

        flip := function(a)
            return Random([1..1000]) <= 1000*a;
        end;

        repeat
            ## propose a new state
            change := propose(cnf);
            AppendTo(fd, "[ ", change, ", ");

            ## apply the proposed change
            ApplyChange(change, cnf);

            ## check to see if we actually want to accept the new state
            prob := check(cnf, change);
            accepted := flip(prob);
            AppendTo(fd, prob, ", ", accepted, " ]\n");
            if not accepted then
                RevertChange(change, cnf);
            fi;
        until not continue_check(cnf, change, prob, accepted);
    end);

InstallGlobalFunction(SimulateGS,
    function (cnf, continue_check, propose, check, fd, update, gs)
        local i, obj, real_continue_check, counter;

        counter := 0;
        real_continue_check := function(cnf, change, prob, accepted)
            local res;

            res := continue_check(cnf, change, prob, accepted);
            if counter = 0 or not res then
                # update the graphic sheet
                for obj in gs!.objects do
                    Delete(obj);
                od;
                DrawConfiguration(cnf, gs);
            fi;
            counter := (counter + 1) mod update;
            return res;
        end;
        Simulate(cnf, real_continue_check, propose, check, fd);
    end);
